local TankOMeter, tom_table = ...

tom_table.eventCFrame = CreateFrame("Frame")

successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("TOMremH")
-- print(successfulRequest)
successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("TOMremT")
-- print(successfulRequest)
successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("TOMaddH")
-- print(successfulRequest)
successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("TOMaddT")
-- print(successfulRequest)

tom_table.eventCFrame:SetScript("OnEvent", function(self, event, prefix, msg, channel, sender)
	-- prefix: prefix
	-- msg: message
	-- channel: channel
	-- sender: sender
	local isin = tom_table.PlayerIsIn()
	if (isin == "bg" or isin == "solo") and tom_table.dev == nil then return end

	local uNameNoServer = sender:match("([^,]+)-([^,]+)")

	if tom_table.dev == 1 then
		print("DEBUG Addon Event triggered")
		print("DEBUG prefix: "..prefix)
		print("DEBUG name: "..msg)
		print("DEBUG channel: "..channel)
		print("DEBUG sender: "..sender)
		print("DEBUG sender ohne server: "..uNameNoServer)
	end

	if prefix == "TOMremH" then
		if tom_table.isHealer(msg) == 1 then
			tom_table.syncRemoveHealer(msg, sender)
		end
	end
	if prefix == "TOMremT" then
		if tom_table.isTank(msg) == 2 then
			tom_table.syncRemoveTank(msg, sender)
		end
	end

	if prefix == "TOMaddH" then
                for i in string.gmatch(msg, "%S+") do
			tom_table.syncAddHealer(i, sender)
		end
	end

	if prefix == "TOMaddT" then
                for i in string.gmatch(msg, "%S+") do
			tom_table.syncAddTank(i, sender)
		end
	end

	if prefix == "TOMRCINI" then
                if uNameNoServer ~= UnitName("player") then
	        	if tom_table.CharSettings.myRoleIs then
				RolePollPopup_Show()
        			tom_table.HideShowFrame(ButtonRolecheck)
				tom_table.HideShowFrame(ButtonOK, true)
				PlaySound(8960)
			end
		end
	end

	if prefix == "TOMRCIam" then
                if uNameNoServer ~= UnitName("player") then
			tom_table.TOM_RoleCheck_Changed()
		end
	end
end)

function tom_table.syncLists() -- send all tanks and healer
	local healer, tanks, hcount, tcount = "", "", 0, 0

	if tom_table.PlayerIsIn() ~= "solo" then
		if tom_table.isHealer(UnitName("player")) == 1 then
			healer = UnitName("player").." "
			hcount = 1
		end

		if tom_table.isTank(UnitName("player")) == 2 then
			tanks = UnitName("player").." "
			tcount = 1

		end

		for i = 1, GetNumGroupMembers() do
			if tom_table.isHealer(UnitName(tom_table.PlayerIsIn() .. i)) == 1 then
				if hcount < 5 then
                                	healer = healer..UnitName(tom_table.PlayerIsIn() .. i).." "
					hcount = hcount + 1
				else
                                        tom_table.syncSendComm("TOMaddH", healer)
					healer, hcount = "", 0
				end
			end

			if tom_table.isTank(UnitName(tom_table.PlayerIsIn() .. i)) == 2 then
				if tcount < 5 then
                                	tanks = tanks..UnitName(tom_table.PlayerIsIn() .. i).." "
					tcount = tcount + 1
				else
                                        tom_table.syncSendComm("TOMaddT", tanks)
					tanks, tcount = "", 0
				end
			end
		end

		if hcount > 0 then
                        tom_table.syncSendComm("TOMaddH", healer)
		end

		if tcount > 0 then
                	tom_table.syncSendComm("TOMaddT", tanks)
		end
	end
end

function tom_table.syncAddHealer(msg, sender) -- receive healer to add
	if tom_table.IsInTable(tom_table.Settings.Healer, msg) == nil then
		table.insert(tom_table.Settings.Healer, msg)
		tom_table.PrintMSG("add healer: "..msg.." by "..sender)
		tom_table.TAL()
		tom_table.HAL()
	end
end

function tom_table.syncAddTank(msg, sender) -- receive tank to add
	if tom_table.IsInTable(tom_table.Settings.Tanks, msg) == nil then
		table.insert(tom_table.Settings.Tanks, msg)
		tom_table.PrintMSG("add tank: "..msg.." by "..sender)
		tom_table.TAL()
		tom_table.HAL()
	end
end

function tom_table.syncRemoveHealer(msg, sender) -- receive healer to remove
	for k, v in pairs(tom_table.Settings.Healer) do
		if msg == v then
	      		table.remove(tom_table.Settings.Healer, k)
			tom_table.PrintMSG("removed healer: "..msg.." by "..sender)
			tom_table.TAL()
			tom_table.HAL()
		end
	end
end

function tom_table.syncRemoveTank(msg, sender) -- receive tank to remove
	for k, v in pairs(tom_table.Settings.Tanks) do
		if msg == v then
	      		table.remove(tom_table.Settings.Tanks, k)
			tom_table.PrintMSG("removed tank: "..msg.." by "..sender)
			tom_table.TAL()
			tom_table.HAL()
		end
	end
end

function tom_table.syncSendComm(prefix, msg) -- send all data channel actions
	local isin = tom_table.PlayerIsIn()
	if (isin == "bg" or isin == "solo") and tom_table.dev == nil then return end

	if tom_table.SYNCstatus then
		success = C_ChatInfo.SendAddonMessage(prefix, msg, tom_table.PlayerIsIn())
		if tom_table.dev == 1 then print(success) end
	end
end

function tom_table.syncToggle()
        tom_table.SYNCstatus = tom_table.TrueFalseSwitch(tom_table.SYNCstatus)
        tom_table.synchandles()
end

function tom_table.synchandles()
	if (tom_table.SYNCstatus) then
		tom_table.eventCFrame:RegisterEvent("CHAT_MSG_ADDON")
	else
		tom_table.eventCFrame:UnregisterEvent("CHAT_MSG_ADDON")
	end
end