local TankOMeter, tom_table = ...
-----------------------------TotemDetector--------------------------------------

function tom_table.TotemCheck()
	local IO = 0
	for i = 1, 40 do							-- buff slots
		if tom_table.IsInTable(tom_table.TotemTextures, select(2, UnitAura("player", i))) then
			IO = IO + 1
		end
	end
        tom_table.TCheck = IO
end

function tom_table.TotemWeaponCheck()
	tom_table.TWCheck = tom_table.WeaponEnchantID() and 1 or 0 
end

function tom_table.ShowHideTotem()
	tom_table.HideShowFrame(tom_table.TiRTexture, (tom_table.TCheck + tom_table.TWCheck))
        tom_table.TiRTexture.Count:SetText(tom_table.TCheck + tom_table.TWCheck)
end

function tom_table.WeaponEnchantID()
	local slotID = GetInventorySlotInfo("MainHandSlot")
	tom_table.TiRTexture.tip:ClearLines()
	tom_table.TiRTexture.tip:SetInventoryItem("player", slotID)
	for i = 6, tom_table.TiRTexture.tip:NumLines() do
		local enchant = _G["TOMWETipTextLeft"..i]:GetText():match("(.+) %(%d+ .+%)")
		if (enchant) then
			tom_table.TiRTexture.tip:ClearLines()
			return tom_table.NameToTotemID[gsub(enchant, "[0-9]+", ""):match( "^%s*(.-)%s*$" )]
		end
	end
	return nil
end

-----------------------------TotemDetector--------------------------------------