local TankOMeter, tom_table = ...
--------------------------------Targets-----------------------------------------

function tom_table.TarFrameBuilder(uisDead, uguid, uname, uhp, umaxhp, isEnemy, lvl)
	if not tom_table.TarGUID[uguid] and uguid and isEnemy then
		--print("new"..time().." "..uguid)
                tom_table.TarGUID[uguid] = {}
                tom_table.TarGUID[uguid].lvl = lvl
                tom_table.TarGUID[uguid].name = uname
		tom_table.TarGUID[uguid].isDead = uisDead == nil and "nil" or uisDead == true and "dead" or "alive"
		tom_table.TarGUID[uguid].hp = uhp == nil and 1 or uhp
		tom_table.TarGUID[uguid].maxhp = umaxhp == nil and 1 or umaxhp
		if tom_table.TarGUID[uguid].hp == tom_table.TarGUID[uguid].maxhp then
			tom_table.TarGUID[uguid].hpp = 100
		else
			tom_table.TarGUID[uguid].hpp = round(tom_table.TarGUID[uguid].hp / (tom_table.TarGUID[uguid].maxhp / 100), 1)
		end
		tom_table.TarGUID[uguid].updatetime = time()
	elseif  tom_table.TarGUID[uguid] and not uisDead then
		--print("update: "..time())
		tom_table.TarGUID[uguid].isDead = uisDead == nil and "nil" or uisDead == true and "dead" or "alive"
		tom_table.TarGUID[uguid].hp = uhp == nil and 1 or uhp
		tom_table.TarGUID[uguid].maxhp = umaxhp == nil and 1 or umaxhp
		if tom_table.TarGUID[uguid].hp == tom_table.TarGUID[uguid].maxhp then
			tom_table.TarGUID[uguid].hpp = 100
		else
			tom_table.TarGUID[uguid].hpp = round(tom_table.TarGUID[uguid].hp / (tom_table.TarGUID[uguid].maxhp / 100), 1)
		end
		tom_table.TarGUID[uguid].updatetime = time()
	elseif  tom_table.TarGUID[uguid] and time()-tom_table.TarSet.timeout >= tom_table.TarGUID[uguid].updatetime then
                tom_table.TarGUID[uguid] = nil
	end
end

function tom_table.IniTarFrame()
	tom_table.TarFrame = tom_table.CreateMyFrame("Tank-O-MeterTargets", UIParent, tom_table.TarSet.anchor, tom_table.TarSet.defaultX, tom_table.TarSet.defaultY, tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.TarFrame:SetUserPlaced(true)
	tom_table.TarFrame:SetFrameStrata("MEDIUM")
	tom_table.TarFrame.texture = tom_table.TarFrame:CreateTexture(nil, "BACKGROUND")
	tom_table.TarFrame.texture:SetAllPoints(true)
	tom_table.TarFrame.texture:SetColorTexture(0, 0, 0, 0.3)
	tom_table.TarFrame.title = tom_table.CreateLabel(tom_table.TarFrame, 0, 0, "ChatFontNormal", tom_table.TarSet.title, "CENTER", "TOP", tom_table.Settings.bWidth, tom_table.Settings.bHeight)

	for i = 1, tom_table.TarSet.maxtar, 1 do
		tom_table.TarFrame["bar"..i] = tom_table.CreateMyBars("TOMTarget"..i, tom_table.TarFrame, 0, -i*tom_table.Settings.bHeight-2, tom_table.Settings.bWidth, tom_table.Settings.bHeight, 1, 0.16, 0, 0.25, 0.04, 0) -- thp
		if tom_table.TarFrame["bar"..i]:IsShown() then tom_table.HideShowFrame(tom_table.TarFrame["bar"..i]) end
	end
end

function tom_table.UpdateTarBars(event)
        if tom_table.Settings.TOHstatus then
		local hptab = {}
		local hptabsorted
		local j = 0
		local g, r, b = 1, 0.16, 0
		if event == "UPDATE_MOUSEOVER_UNIT" and UnitIsEnemy("player","mouseover") then tom_table.TarFrameBuilder(UnitIsDead("mouseover"), UnitGUID("mouseover"), UnitName("mouseover"), UnitHealth("mouseover"), UnitHealthMax("mouseover"), UnitIsEnemy("player","mouseover"), UnitLevel("mouseover")) elseif event == "PLAYER_TARGET_CHANGED" and UnitIsEnemy("player","TARGET") then tom_table.TarFrameBuilder(UnitIsDead("TARGET"), UnitGUID("TARGET"), UnitName("TARGET"), UnitHealth("TARGET"), UnitHealthMax("TARGET"), UnitIsEnemy("player","TARGET"), UnitLevel("TARGET")) end
		for uguid, v1 in pairs(tom_table.TarGUID) do
		        if tom_table.TarGUID[uguid].maxhp ~= 0 and tom_table.TarGUID[uguid].isDead == "alive" and time()-tom_table.TarSet.timeout <= tom_table.TarGUID[uguid].updatetime then hptab[uguid] = tom_table.TarGUID[uguid].hp end
			if time()-tom_table.TarSet.timeout > tom_table.TarGUID[uguid].updatetime then tom_table.TarGUID[uguid] = nil end
		end
		hptabsorted = tom_table.getKeysSortedByValue(hptab, function(a, b) return a > b end)
		for i, uguid in ipairs(hptabsorted) do
			if i > tom_table.TarSet.maxtar then
	                        tom_table.TarGUID[uguid] = nil
			else
				tom_table.HideShowFrame(tom_table.TarFrame["bar"..i], true)
				tom_table.TarFrame["bar"..i].tooltip = "("..tom_table.TarGUID[uguid].lvl..") "..tom_table.TarGUID[uguid].name.." "..tom_table.TarGUID[uguid].hp.."/"..tom_table.TarGUID[uguid].maxhp
				tom_table.TarFrame["bar"..i].value:SetText("("..tom_table.TarGUID[uguid].lvl..") "..(tom_table.TarGUID[uguid].name):sub(1,24))
				tom_table.TarFrame["bar"..i].value2:SetText(tom_table.TarGUID[uguid].hpp.."/100")
				tom_table.TarFrame["bar"..i].health = tom_table.TarGUID[uguid].hp
				tom_table.TarFrame["bar"..i].maxhealth = tom_table.TarGUID[uguid].maxhp
				tom_table.TarFrame["bar"..i].healthPrecent = tom_table.TarGUID[uguid].healthprecent
				tom_table.TarFrame["bar"..i]:SetMinMaxValues(0,tom_table.TarGUID[uguid].maxhp)
				tom_table.TarFrame["bar"..i]:SetValue(tom_table.TarGUID[uguid].hp)
				tom_table.TarFrame["bar"..i]:SetScript("OnEnter", tom_table.OnEnterFrame)
				tom_table.TarFrame["bar"..i]:SetScript("OnLeave", tom_table.OnLeaveFrame)
	                        tom_table.TarFrame["bar"..i]:EnableMouse(tom_table.BarToolTipStatus)

				if time()-(tom_table.TarSet.timeout/20*5) > tom_table.TarGUID[uguid].updatetime then
		                        tom_table.TarFrame["bar"..i]:SetStatusBarColor(g, r, b, tom_table.Settings.bAlpha/10*2)
				elseif time()-(tom_table.TarSet.timeout/20*3) > tom_table.TarGUID[uguid].updatetime then
		                        tom_table.TarFrame["bar"..i]:SetStatusBarColor(g, r, b, tom_table.Settings.bAlpha/10*4)
				elseif time()-(tom_table.TarSet.timeout/20*2) > tom_table.TarGUID[uguid].updatetime then
		                        tom_table.TarFrame["bar"..i]:SetStatusBarColor(g, r, b, tom_table.Settings.bAlpha/10*6)
				elseif time()-(tom_table.TarSet.timeout/20) > tom_table.TarGUID[uguid].updatetime then
		                        tom_table.TarFrame["bar"..i]:SetStatusBarColor(g, r, b, tom_table.Settings.bAlpha/10*8)
				else
		                        tom_table.TarFrame["bar"..i]:SetStatusBarColor(g, r, b, tom_table.Settings.bAlpha)
				end
			end
			j = i
		end
		if j < tom_table.TarSet.maxtar then
			for i=j+1, tom_table.TarSet.maxtar do
		        	if tom_table.TarFrame["bar"..i]:IsShown() then tom_table.HideShowFrame(tom_table.TarFrame["bar"..i]) end
			end
		end
	end
end

function tom_table.ToggleTARHISTORY()
        tom_table.Settings.TOHstatus = tom_table.TrueFalseSwitch(tom_table.Settings.TOHstatus)
	tom_table.ToggleTARHISTORYevents()
        tom_table.HideShowFrame(tom_table.TarFrame, tom_table.Settings.TOHstatus)
end

function tom_table.ToggleTARHISTORYevents()
	if tom_table.Settings.TOHstatus and not UIParent:IsEventRegistered("UPDATE_MOUSEOVER_UNIT") and not UIParent:IsEventRegistered("PLAYER_TARGET_CHANGED") then
		tom_table.eventFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		tom_table.eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
	elseif not tom_table.Settings.TOHstatus and UIParent:IsEventRegistered("UPDATE_MOUSEOVER_UNIT") and UIParent:IsEventRegistered("PLAYER_TARGET_CHANGED") then
		tom_table.eventFrame:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
		tom_table.eventFrame:UnregisterEvent("PLAYER_TARGET_CHANGED")
	end
end